/* -*- mode: c++ -*-
  CPP_CONTEST=2012-CUDA
  CPP_PROBLEM=A
  CPP_LANG=CUDA1+OPENMP
*/

/* RECORD
Alejandro Chacón de San Baldomero, Tomàs Artés Vivancos
students of the University Autónoma de Barcelona
In the II Spanish Parallel Programming Contest, Elche, Spain
OpenMP+CUDA test
September 20, 2012
time 334 msec
speed-up 2.53
*/

#include <stdlib.h>
#include <omp.h>
#include <cutil_inline.h>

void Image_Smoothing_by_Filtering(unsigned char *Image, unsigned int Size, int Rep)
{
  int
     k;
 unsigned int
     stride, i, j,auxil ,tauxi,auxi,auxis,threadId,nthreads;

  unsigned char
     *tImage=NULL,
	 *nImage=NULL;

  nthreads=4;
  /* Vectores para almacenamiento temporal */
  /*
  tImage = (unsigned char *)calloc((Size+2)*nthreads, sizeof(unsigned char));
  aImage = (unsigned char *)calloc((Size+2)*nthreads, sizeof(unsigned char));
	*/
  nImage = (unsigned char *)calloc(((Size+2)*(Size+2)), sizeof(unsigned char));

  stride = Size+2;

  omp_set_num_threads(4);
  for (k=1; k<=Rep; k++)
  {
    // memcpy(tImage, Imagen, stride);
     #pragma omp parallel for schedule(static) default(shared) private(auxi,tauxi,auxil,auxis,j,i)
	 for(i=0; i<=Size+1; i++)
     {
		//tImage = (unsigned char *)calloc(Size+2, sizeof(unsigned char));
 		//aImage = (unsigned char *)calloc(Size+2, sizeof(unsigned char));

        //memcpy(aImage, tImage,            stride);
        //memcpy(tImage, &Imagen[i*stride], stride);
		//auxi=(i)*stride;
        for(j=0; j<=Size+1; j++)
        {
		
           tauxi=(i*stride)+j;
		   auxil=tauxi+stride;
		   auxis=tauxi-stride;
			if ( i==Size+1 | i==0 | j==0 | j==Size+1 ) {
				nImage[tauxi]=Image[tauxi];
			}else{
           		nImage[tauxi]=(Image[auxis-1]     + Image[auxis]    + Image[auxis+1] +
                	              Image[tauxi-1]  + Image[tauxi]    + Image[tauxi+1] +
                    	           Image[auxil-1] + Image[auxil] + Image[auxil+1]) / 9;
		  }
        }
     }
    tImage=Image;
 	Image=nImage;
 	nImage=tImage; 
 }
  memcpy(nImage, Image, (Size+2)*(Size+2));
}


